using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Drawing;

using Dauphine.Web.UI.SmartControls.Design;

namespace Dauphine.Web.UI.SmartControls
{
    [DefaultProperty("ClientContextManagerID")]
    [Designer(typeof(ActionsListControlDesigner))]
    [ToolboxBitmap(typeof(ActionsDropDownList))]
    [ToolboxData(@"<{0}:ActionsDropDownList runat=""server""></{0}:ActionsDropDownList>")]
    public class ActionsDropDownList : DropDownList, IActionList
    {
        private const string DefaultValue_ClientContextManagerID = "";
        private const bool DefaultValue_EnableNullSelectedItem = true;
        private const string DefaultValue_NullSelectedItemText = "......";
        private const string DefaultValue_NullSelectedItemValue = "";

        [DefaultValue(DefaultValue_ClientContextManagerID)]
        [SmartDescription("DescriptionAttribute_ActionsListControl_ClientContextManagerID")]
        [SmartCategory("CategoryAttribute_ActionsListControl_ClientContextManagerID")]
        [IDReferenceProperty(typeof(ClientContextManager))]
        [TypeConverter(typeof(ClientContextManagerConverter))]
        public string ClientContextManagerID
        {
            get
            {
                Object oObj = ViewState["ClientContextManagerID"];

                if (oObj == null)
                {
                    ViewState["ClientContextManagerID"] = DefaultValue_ClientContextManagerID;
                }

                return ViewState["ClientContextManagerID"] + string.Empty;
            }

            set
            {
                ViewState["ClientContextManagerID"] = value;
            }
        }

        [DefaultValue(DefaultValue_EnableNullSelectedItem)]
        [SmartDescription("DescriptionAttribute_ActionsListControl_EnableNullSelectedItem")]
        [SmartCategory("CategoryAttribute_ActionsListControl_EnableNullSelectedItem")]
        public bool EnableNullSelectedItem
        {
            get
            {
                object oObj = ViewState["EnableNullSelectedItem"];

                if (oObj == null)
                {
                    ViewState["EnableNullSelectedItem"] = DefaultValue_EnableNullSelectedItem;
                }

                return Convert.ToBoolean(ViewState["EnableNullSelectedItem"]);
            }

            set
            {
                ViewState["EnableNullSelectedItem"] = value;
            }
        }

        [DefaultValue(DefaultValue_NullSelectedItemText)]
        [SmartDescription("DescriptionAttribute_ActionsListControl_NullSelectedItemText")]
        [SmartCategory("CategoryAttribute_ActionsListControl_NullSelectedItemText")]
        public string NullSelectedItemText
        {
            get
            {
                if((ViewState["NullSelectedItemText"] + string.Empty) == string.Empty)
                {
                    ViewState["NullSelectedItemText"] = DefaultValue_NullSelectedItemText;
                }

                return ViewState["NullSelectedItemText"] + string.Empty;
            }

            set
            {
                ViewState["NullSelectedItemText"] = value;
            }
        }

        [DefaultValue(DefaultValue_NullSelectedItemValue)]
        [SmartDescription("DescriptionAttribute_ActionsListControl_NullSelectedItemValue")]
        [SmartCategory("CategoryAttribute_ActionsListControl_NullSelectedItemValue")]
        public string NullSelectedItemValue
        {
            get
            {
                if((ViewState["NullSelectedItemValue"] + string.Empty) == string.Empty)
                {
                    ViewState["NullSelectedItemValue"] = DefaultValue_NullSelectedItemValue;
                }

                return ViewState["NullSelectedItemValue"] + string.Empty;
            }

            set
            {
                ViewState["NullSelectedItemValue"] = value;
            }
        }

        public string GetSelectedAction()
        {
            return this.SelectedValue;
        }

        protected override void OnLoad(EventArgs e)
        {
            ClientContextManager clientContextManager = null;

            try
            { 
                base.OnLoad(e);

                if (!this.Page.IsPostBack)
                {
                    clientContextManager = Utility.FindClientContextManager(this, this.ClientContextManagerID);

                    if (this.EnableNullSelectedItem)
                    {
                        this.Items.Add(new ListItem(this.NullSelectedItemText, this.NullSelectedItemValue));
                    }

                    foreach (string action in clientContextManager.Actions)
                    {
                        this.Items.Add(action);
                    }
                }
            }
            catch
            {
                throw;
            }
        }
    }
}
