using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Drawing;

using Dauphine.Web.UI.SmartControls.Design;

namespace Dauphine.Web.UI.SmartControls
{
    [DefaultProperty("ClientContextManagerID")]
    [Designer(typeof(ActionsListControlDesigner))]
    [ToolboxBitmap(typeof(ActionsRadioButtonList))]
    [ToolboxData(@"<{0}:ActionsRadioButtonList runat=""server""></{0}:ActionsRadioButtonList>")]
    public class ActionsRadioButtonList : RadioButtonList, IActionList
    {
        private const string DefaultValue_ClientContextManagerID = "";

        [DefaultValue(DefaultValue_ClientContextManagerID)]
        [SmartDescription("DescriptionAttribute_ActionsListControl_ClientContextManagerID")]
        [SmartCategory("CategoryAttribute_ActionsListControl_ClientContextManagerID")]
        [IDReferenceProperty(typeof(ClientContextManager))]
        [TypeConverter(typeof(ClientContextManagerConverter))]        
        public string ClientContextManagerID
        {
            get
            {
                Object oObj = ViewState["WorkflowContextManagerID"];

                if (oObj == null)
                {
                    ViewState["WorkflowContextManagerID"] = DefaultValue_ClientContextManagerID;
                }

                return ViewState["WorkflowContextManagerID"] + string.Empty;
            }

            set
            {
                ViewState["ClientContextManagerID"] = value;
            }
        }

        public string GetSelectedAction()
        {
            return this.SelectedValue;
        }

        protected override void OnLoad(EventArgs e)
        {
            ClientContextManager clientContextManager = null;

            try
            {
                base.OnLoad(e);

                if (!this.Page.IsPostBack)
                {
                    clientContextManager = Utility.FindClientContextManager(this, this.ClientContextManagerID);

                    foreach (string action in clientContextManager.Actions)
                    {
                        Items.Add(action);
                    }
                }
            }
            catch
            {
                throw;
            }
        }
    }
}
