using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;

namespace Dauphine.Web.UI.SmartControls.Design
{
    [AttributeUsage(AttributeTargets.All)]
    internal class SmartDescriptionAttribute : DescriptionAttribute
    {
        private bool _bReplaced = false;

        internal SmartDescriptionAttribute(string strDescription) : base(strDescription)
        {

        }

        public override string Description
        {
            get
            {
                if (!_bReplaced)
                {
                    _bReplaced = true;

                    this.DescriptionValue = Resources.ResourceManager.GetString(base.DescriptionValue);
                }

                return this.DescriptionValue;
            }
        }

        public override object TypeId
        {
            get
            {
                return typeof(DescriptionAttribute);
            }
        }
    }
}
