using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing.Design;
using System.Web.UI;
using System.Web.UI.Design;
using System.Web.UI.WebControls;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class ActionButtonDesignerActionList : ActionList
    {
        [IDReferenceProperty(typeof(ClientContextManager))]
        [TypeConverter(typeof(ClientContextManagerConverter))]
        public string ClientContextManagerID
        {
            get
            {
                return this.GetComponentPropertyValue("ClientContextManagerID") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("ClientContextManagerID", value);

                this.ResetComponentPropertyValue("EventAction");
            }
        }

        [Editor(typeof(EventActionEditor), typeof(UITypeEditor))]
        public string EventAction
        {
            get
            {
                return this.GetComponentPropertyValue("EventAction") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("EventAction", value);
            }
        }

        [UrlProperty("*.aspx")]
        [Editor(typeof(UrlEditor), typeof(UITypeEditor))]
        public string RedirectUrl
        {
            get
            {
                return this.GetComponentPropertyValue("RedirectUrl") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("RedirectUrl", value);
            }
        }

        public ActionButtonDesignerActionList(IComponent component) : base(component)
        {

        }

        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection designerActionItemCollection = new DesignerActionItemCollection();

            designerActionItemCollection.Add(new DesignerActionPropertyItem("ClientContextManagerID", Resources.SmartTag_Control_ClientContextManagerID_DisplayName, Resources.SmartTag_Control_ClientContextManagerID_Category, Resources.SmartTag_Control_ClientContextManagerID_Description));

            if (this.ClientContextManagerID.Length != 0)
            {
                designerActionItemCollection.Add(new DesignerActionPropertyItem("EventAction", Resources.SmartTag_ActionButton_EventAction_DisplayName, Resources.SmartTag_ActionButton_EventAction_Category, Resources.SmartTag_ActionButton_EventAction_Description));
            }

            designerActionItemCollection.Add(new DesignerActionPropertyItem("RedirectUrl", Resources.SmartTag_Button_RedirectUrl_DisplayName, Resources.SmartTag_Button_RedirectUrl_Category, Resources.SmartTag_Button_RedirectUrl_Description));

            return designerActionItemCollection;
        }
    }
}
