using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing.Design;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class ClientContextManagerDesignerActionList : ActionList
    {
        [Editor(typeof(HostEditor), typeof(UITypeEditor))]
        public string Host
        {
            get
            {
                return this.GetComponentPropertyValue("Host") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("Host", value);

                this.ResetComponentPropertyValue("Process");
            }
        }

        [Editor(typeof(ProcessEditor), typeof(UITypeEditor))]
        public string Process
        {
            get
            {
                return this.GetComponentPropertyValue("Process") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("Process", value);

                this.ResetComponentPropertyValue("Activity");
            }
        }

        [Editor(typeof(ActivityEditor), typeof(UITypeEditor))]
        public string Activity
        {
            get
            {
                return this.GetComponentPropertyValue("Activity") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("Activity", value);
            }
        }

        public bool AllocateSlot
        {
            get
            {
                return Convert.ToBoolean(this.GetComponentPropertyValue("AllocateSlot"));
            }

            set
            {
                this.SetComponentPropertyValue("AllocateSlot", value);
            }
        }

        public bool IgnoreStatus
        {
            get
            {
                return Convert.ToBoolean(this.GetComponentPropertyValue("IgnoreStatus"));
            }

            set
            {
                this.SetComponentPropertyValue("IgnoreStatus", value);
            }
        }

        public ClientContextManagerDesignerActionList(IComponent component) : base(component)
        {

        }

        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection designerActionItemCollection = new DesignerActionItemCollection();
            
            designerActionItemCollection.Add(new DesignerActionPropertyItem("Host", Resources.SmartTag_WorkflowContextManager_Host_DisplayName, Resources.SmartTag_WorkflowContextManager_Host_Category, Resources.SmartTag_WorkflowContextManager_Host_Description));

            if (this.Host.Length != 0)
            {
                designerActionItemCollection.Add(new DesignerActionPropertyItem("Process", Resources.SmartTag_WorkflowContextManager_Process_DisplayName, Resources.SmartTag_WorkflowContextManager_Process_Category, Resources.SmartTag_WorkflowContextManager_Process_Description));

                if (this.Process.Length != 0)
                {
                    designerActionItemCollection.Add(new DesignerActionPropertyItem("Activity", Resources.SmartTag_ClientContextManager_Activity_DisplayName, Resources.SmartTag_ClientContextManager_Activity_Category, Resources.SmartTag_ClientContextManager_Activity_Description));
                    designerActionItemCollection.Add(new DesignerActionPropertyItem("AllocateSlot", Resources.SmartTag_ClientContextManager_AllocateSlot_DisplayName, Resources.SmartTag_ClientContextManager_AllocateSlot_Category, Resources.SmartTag_ClientContextManager_AllocateSlot_Description));
                    designerActionItemCollection.Add(new DesignerActionPropertyItem("IgnoreStatus", Resources.SmartTag_ClientContextManager_IgnoreStatus_DisplayName, Resources.SmartTag_ClientContextManager_IgnoreStatus_Category, Resources.SmartTag_ClientContextManager_IgnoreStatus_Description));                    
                }
            }

            return designerActionItemCollection;
        }
    }
}
