using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing.Design;
using System.Web.UI;
using System.Web.UI.Design;
using System.Web.UI.WebControls;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class CompleteButtonDesignerActionList : ActionList
    {
        [IDReferenceProperty(typeof(ClientContextManager))]
        [TypeConverter(typeof(ClientContextManagerConverter))]
        public string ClientContextManagerID
        {
            get
            {
                return this.GetComponentPropertyValue("ClientContextManagerID") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("ClientContextManagerID", value);
            }
        }

        [IDReferenceProperty(typeof(WebControl))]
        [TypeConverter(typeof(ActionsListControlConverter))]
        public string ActionsListControlID
        {
            get
            {
                return this.GetComponentPropertyValue("ActionsListControlID") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("ActionsListControlID", value);
            }
        }

        [UrlProperty("*.aspx")]
        [Editor(typeof(UrlEditor), typeof(UITypeEditor))]
        public string RedirectUrl
        {
            get
            {
                return this.GetComponentPropertyValue("RedirectUrl") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("RedirectUrl", value);
            }
        }


        public CompleteButtonDesignerActionList(IComponent component) : base(component)
        {

        }

        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection designerActionItemCollection = new DesignerActionItemCollection();

            designerActionItemCollection.Add(new DesignerActionPropertyItem("ClientContextManagerID", Resources.SmartTag_Control_ClientContextManagerID_DisplayName, Resources.SmartTag_Control_ClientContextManagerID_Category, Resources.SmartTag_Control_ClientContextManagerID_Description));
            designerActionItemCollection.Add(new DesignerActionPropertyItem("ActionsListControlID", Resources.SmartTag_CompleteButton_ActionsListControlID_DisplayName, Resources.SmartTag_CompleteButton_ActionsListControlID_Category, Resources.SmartTag_CompleteButton_ActionsListControlID_Description));
            designerActionItemCollection.Add(new DesignerActionPropertyItem("RedirectUrl", Resources.SmartTag_Button_RedirectUrl_DisplayName, Resources.SmartTag_Button_RedirectUrl_Category, Resources.SmartTag_Button_RedirectUrl_Description));

            return designerActionItemCollection;
        }
    }
}
