using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing.Design;
using System.Web.UI;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class FieldControlActionList : ActionList
    {
        [IDReferenceProperty(typeof(WorkflowContextManager))]
        [TypeConverter(typeof(WorkflowContextManagerConverter))]
        public string WorkflowContextManagerID
        {
            get
            {
                return this.GetComponentPropertyValue("WorkflowContextManagerID") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("WorkflowContextManagerID", value);

                this.ResetComponentPropertyValue("Field");
                this.ResetComponentPropertyValue("Scope");
                this.ResetComponentPropertyValue("Type");
            }
        }

        [Editor(typeof(FieldEditor), typeof(UITypeEditor))]
        public string Field
        {
            get
            {
                return this.GetComponentPropertyValue("Field") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("Field", value);
            }
        }

        public FieldScope Scope
        {
            get
            {
                return (FieldScope)this.GetComponentPropertyValue("Scope");
            }

            set
            {
                this.SetComponentPropertyValue("Scope", value);
            }
        }

        public FieldType Type
        {
            get
            {
                return (FieldType)this.GetComponentPropertyValue("Type");
            }

            set
            {
                this.SetComponentPropertyValue("Type", value);
            }
        }

        public FieldControlActionList(IComponent component) : base(component)
        {
            
        }

        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection designerActionItemCollection = new DesignerActionItemCollection();
            
            designerActionItemCollection.Add(new DesignerActionPropertyItem("WorkflowContextManagerID", Resources.SmartTag_FieldControl_WorkflowContextManagerID_DisplayName, Resources.SmartTag_FieldControl_WorkflowContextManagerID_Category, Resources.SmartTag_FieldControl_WorkflowContextManagerID_Description));

            if (this.WorkflowContextManagerID.Length != 0)
            {
                designerActionItemCollection.Add(new DesignerActionPropertyItem("Field", Resources.SmartTag_FieldControl_Field_DisplayName, Resources.SmartTag_FieldControl_Field_Category, Resources.SmartTag_FieldControl_Field_Description));

                if (!this.IsComponentPropertyReadOnly("Scope"))
                {
                    designerActionItemCollection.Add(new DesignerActionPropertyItem("Scope", Resources.SmartTag_FieldControl_Scope_DisplayName, Resources.SmartTag_FieldControl_Scope_Category, Resources.SmartTag_FieldControl_Scope_Description));
                }

                if (!this.IsComponentPropertyReadOnly("Type"))
                {
                    designerActionItemCollection.Add(new DesignerActionPropertyItem("Type", Resources.SmartTag_FieldControl_Type_DisplayName, Resources.SmartTag_FieldControl_Type_Category, Resources.SmartTag_FieldControl_Type_Description));
                }
            }

            return designerActionItemCollection;
        }
    }
}

