using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing.Design;
using System.Web.UI;
using System.Web.UI.Design;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class RedirectButtonDesignerActionList : ActionList
    {
        [UrlProperty("*.aspx")]
        [Editor(typeof(UrlEditor), typeof(UITypeEditor))]
        public string RedirectUrl
        {
            get
            {
                return this.GetComponentPropertyValue("RedirectUrl") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("RedirectUrl", value);
            }
        }
        
        public RedirectButtonDesignerActionList(IComponent component) : base(component)
        {

        }

        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection designerActionItemCollection = new DesignerActionItemCollection();
                    
            designerActionItemCollection.Add(new DesignerActionPropertyItem("RedirectUrl", Resources.SmartTag_Button_RedirectUrl_DisplayName, Resources.SmartTag_Button_RedirectUrl_Category, Resources.SmartTag_Button_RedirectUrl_Description));
            
            return designerActionItemCollection;
        }
    }
}
