using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing.Design;
using System.Web.UI;
using System.Web.UI.Design;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class StartButtonDesignerActionList : ActionList
    {
        [IDReferenceProperty(typeof(StartContextManager))]
        [TypeConverter(typeof(StartContextManagerConverter))]
        public string StartContextManagerID
        {
            get
            {
                return this.GetComponentPropertyValue("StartContextManagerID") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("StartContextManagerID", value);
            }
        }

        [UrlProperty("*.aspx")]
        [Editor(typeof(UrlEditor), typeof(UITypeEditor))]
        public string RedirectUrl
        {
            get
            {
                return this.GetComponentPropertyValue("RedirectUrl") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("RedirectUrl", value);
            }
        }


        public StartButtonDesignerActionList(IComponent component) : base(component)
        {

        }

        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection designerActionItemCollection = new DesignerActionItemCollection();

            designerActionItemCollection.Add(new DesignerActionPropertyItem("StartContextManagerID", Resources.SmartTag_Control_StartContextManagerID_DisplayName, Resources.SmartTag_Control_StartContextManagerID_Category, Resources.SmartTag_Control_StartContextManagerID_Description));
            designerActionItemCollection.Add(new DesignerActionPropertyItem("RedirectUrl", Resources.SmartTag_Button_RedirectUrl_DisplayName, Resources.SmartTag_Button_RedirectUrl_Category, Resources.SmartTag_Button_RedirectUrl_Description));

            return designerActionItemCollection;
        }
    }
}
