using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing.Design;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class StartContextManagerDesignerActionList : ActionList
    {
        [Editor(typeof(HostEditor), typeof(UITypeEditor))]
        public string Host
        {
            get
            {
                return this.GetComponentPropertyValue("Host") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("Host", value);

                this.ResetComponentPropertyValue("Process");
            }
        }

        [Editor(typeof(ProcessEditor), typeof(UITypeEditor))]
        public string Process
        {
            get
            {
                return this.GetComponentPropertyValue("Process") + string.Empty;
            }

            set
            {
                this.SetComponentPropertyValue("Process", value);
            }
        }

        public bool Synchronous
        {
            get
            {
                return Convert.ToBoolean(this.GetComponentPropertyValue("Synchronous"));
            }

            set
            {
                this.SetComponentPropertyValue("Synchronous", value);
            }
        }

        public StartContextManagerDesignerActionList(IComponent component) : base(component)
        {

        }        

        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection designerActionItemCollection = new DesignerActionItemCollection();

            designerActionItemCollection.Add(new DesignerActionPropertyItem("Host", Resources.SmartTag_WorkflowContextManager_Host_DisplayName, Resources.SmartTag_WorkflowContextManager_Host_Category, Resources.SmartTag_WorkflowContextManager_Host_Description));

            if (this.Host.Length != 0)
            {
                designerActionItemCollection.Add(new DesignerActionPropertyItem("Process", Resources.SmartTag_WorkflowContextManager_Process_DisplayName, Resources.SmartTag_WorkflowContextManager_Process_Category, Resources.SmartTag_WorkflowContextManager_Process_Description));
                designerActionItemCollection.Add(new DesignerActionPropertyItem("Synchronous", Resources.SmartTag_StartContextManager_Synchronous_DisplayName, Resources.SmartTag_StartContextManager_Synchronous_Category, Resources.SmartTag_StartContextManager_Synchronous_Description));
            }
            
            return designerActionItemCollection;
        }
    }
}
