using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;

using System.Collections;
using System.ComponentModel.Design;
using System.Web.UI.WebControls;
using System.Web.UI.Design.WebControls;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class ActionsListControlDesigner : ListControlDesigner
    {
        protected override bool UsePreviewControl
        {
            get
            {
                return true;
            }
        }

        public override DesignerActionListCollection ActionLists
        {
            get
            {
                DesignerActionListCollection designerActionListCollection = null;

                designerActionListCollection = base.ActionLists;

                designerActionListCollection.Add(new ActionsListControlDesignerActionList(this.Component));

                return designerActionListCollection;
            }
        }

        public override string GetDesignTimeHtml()
        {
            ActionsDropDownList actionsDropDownList = null;
            ActionsRadioButtonList actionsRadioButtonList = null;
            string strDesignTimeHtml = string.Empty;

            try
            {
                if ((ListControl)base.ViewControl is ActionsDropDownList)
                {
                    actionsDropDownList = (ActionsDropDownList)base.ViewControl;

                    actionsDropDownList.Items.Clear();

                    if (actionsDropDownList.EnableNullSelectedItem)
                    {
                        actionsDropDownList.Items.Add(actionsDropDownList.NullSelectedItemText);
                    }

                    actionsDropDownList.Items.Add(Resources.DesignerPreview_ActionsDropDownListItem_Text);

                    strDesignTimeHtml = base.GetDesignTimeHtml();
                }
                else if ((ListControl)base.ViewControl is ActionsRadioButtonList)
                {
                    actionsRadioButtonList = (ActionsRadioButtonList)base.ViewControl;

                    actionsRadioButtonList.Items.Clear();

                    for (int i = 1; i <= 3; i++)
                    {
                        actionsRadioButtonList.Items.Add(string.Format(Resources.DesignerPreview_ActionsRadioButtonListItem_Text, i));
                    }

                    strDesignTimeHtml = base.GetDesignTimeHtml();
                }
                else
                {
                    strDesignTimeHtml = base.GetDesignTimeHtml();
                }
            }
            catch (Exception exp)
            {
                strDesignTimeHtml = this.GetErrorDesignTimeHtml(exp);
            }

            return strDesignTimeHtml;
        }

        protected override void PreFilterProperties(IDictionary properties)
        {
            properties.Remove("AppendDataBoundItems");
            properties.Remove("DataSource");
            properties.Remove("DataSourceID");
            properties.Remove("DataMember");
            properties.Remove("DataTextField");
            properties.Remove("DataValueField");
            properties.Remove("DataTextFormatString");
            properties.Remove("Items"); 
        }
    }
}
