using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;

using SourceCode.Workflow.Management;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class ActivityEditor : Editor
    {
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext typeDescriptorContext)
        {
            return UITypeEditorEditStyle.Modal;
        }        

        public override object EditValue(ITypeDescriptorContext typeDescriptorContext, IServiceProvider serviceProvider, object oValue)
        {
            IWindowsFormsEditorService windowsFormsEditorService = null;
            ActivityPickerForm activityPicker = null;
            Activity activity = null;
            ActionList actionList = null;
            ClientContextManager clientContextManager = null;

            try
            {
                if (typeDescriptorContext.Instance != null && serviceProvider != null)
                {
                    windowsFormsEditorService = (IWindowsFormsEditorService)serviceProvider.GetService(typeof(IWindowsFormsEditorService));

                    if (windowsFormsEditorService != null)
                    {
                        if (typeDescriptorContext.Instance is ActionList)
                        {
                            actionList = (ActionList)typeDescriptorContext.Instance;

                            clientContextManager = (ClientContextManager)actionList.Component;
                        }
                        else
                        {
                            clientContextManager = (ClientContextManager)typeDescriptorContext.Instance;
                        }

                        activityPicker = new ActivityPickerForm(clientContextManager);

                        if (windowsFormsEditorService.ShowDialog(activityPicker) == DialogResult.OK)
                        {
                            activity = (Activity)activityPicker.Value;

                            oValue = activity.Name;
                        }
                    }
                }
            }
            catch (Exception exp)
            {
                this.DisplayError(serviceProvider, exp);
            }

            return oValue;
        }
    }
}
