using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class Editor : UITypeEditor
    {
        protected void DisplayError(IServiceProvider serviceProvider, Exception exp)
        {
            IUIService uiService = null;
            string strMessage = string.Empty;

            uiService = (IUIService)serviceProvider.GetService(typeof(IUIService));

            if (uiService != null)
            {
                uiService.ShowError(exp);
            }
            else
            {
                strMessage = exp.Message;

                if (strMessage == null || strMessage.Length == 0)
                {
                    strMessage = exp.ToString();
                }

                MessageBox.Show(null, strMessage, null, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
            }
        } 
    }
}
