using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Windows.Forms.Design;

namespace Dauphine.Web.UI.SmartControls.Design
{
    public partial class EditorForm : Form
    {
        public virtual object Value
        {
            get
            {
                return null;
            }
        }

        protected virtual bool IsValid
        {
            get
            {
                return false;
            }
        }

        public EditorForm()
        {
            InitializeComponent();
        }

        protected void HandleError(Exception exp)
        {
            IUIService uiService = null;
            string strMessage = string.Empty;

            uiService = (IUIService)this.GetService(typeof(IUIService));

            if (uiService != null)
            {
                uiService.ShowError(exp);
            }
            else
            {
                strMessage = exp.Message;

                if (strMessage == null || strMessage.Length == 0)
                {
                    strMessage = exp.ToString();
                }

                MessageBox.Show(this, strMessage, null, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
            }

            this.DialogResult = DialogResult.Abort;

            this.Close();
        }        
    }
}