using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;

using SourceCode.Workflow.Management;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class EventActionEditor : Editor
    {
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext typeDescriptorContext)
        {
            return UITypeEditorEditStyle.Modal;
        }        

        public override object EditValue(ITypeDescriptorContext typeDescriptorContext, IServiceProvider serviceProvider, object oValue)
        {            
            IWindowsFormsEditorService windowsFormsEditorService = null;
            EventActionPickerForm actionPicker = null;
            System.Web.UI.Control control = null;
            EventAction eventAction = null;
            ActionList actionList = null;

            try
            {
                if (typeDescriptorContext.Instance != null && serviceProvider != null)
                {
                    windowsFormsEditorService = (IWindowsFormsEditorService)serviceProvider.GetService(typeof(IWindowsFormsEditorService));

                    if (windowsFormsEditorService != null)
                    {
                        if (typeDescriptorContext.Instance is ActionList)
                        {
                            actionList = (ActionList)typeDescriptorContext.Instance;

                            control = (System.Web.UI.Control)actionList.Component;
                        }
                        else
                        {
                            control = (System.Web.UI.Control)typeDescriptorContext.Instance;
                        }

                        actionPicker = new EventActionPickerForm(control);

                        if (windowsFormsEditorService.ShowDialog(actionPicker) == DialogResult.OK)
                        {
                            eventAction = (EventAction)actionPicker.Value;

                            oValue = eventAction.Name;
                        }
                    }
                }
            }
            catch (Exception exp)
            {
                this.DisplayError(serviceProvider, exp);
            }

            return oValue;
        }
    }    
}
