using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using SourceCode.Data.SmartObjectsClient;

namespace Dauphine.Web.UI.SmartControls.Design
{
    partial class HostEditorForm : EditorForm
    {
        public WorkflowContextManager _workflowContextManager = null;

        public override object Value
        {
            get
            {
                return hostComboBox.Text.Trim();
            }
        }

        protected override bool IsValid
        {
            get
            {
                string strHost = string.Empty;

                strHost = hostComboBox.Text.Trim();

                return (strHost.Length != 0);
            }
        }

        public HostEditorForm(WorkflowContextManager workflowContextManager)
        {
            try
            {               
                InitializeComponent();

                hostComboBox.Text = workflowContextManager.Host;

                okButton.Enabled = this.IsValid;
            }
            catch
            {
                throw;
            }
        }

        private void PopulateObjects()
        {
            string strHost = string.Empty;

            try
            {
                Cursor.Current = Cursors.WaitCursor;

                hostComboBox.SuspendLayout();

                strHost = hostComboBox.Text;

                hostComboBox.DisplayMember = hostComboBox.ValueMember = "ServerName";

                hostComboBox.DataSource = SODataSourceEnumerator.Instance.GetDataSources();

                hostComboBox.Text = strHost;
            }
            catch
            {
                throw;
            }
            finally
            {
                hostComboBox.ResumeLayout();

                Cursor.Current = Cursors.Default;
            }
        }

        private void hostComboBox_DropDown(object sender, EventArgs e)
        {
            try
            {
                if (hostComboBox.Items.Count == 0)
                {
                    PopulateObjects();
                }
            }
            catch (Exception exp)
            {
                this.HandleError(exp);
            }
        }

        private void hostComboBox_TextUpdate(object sender, EventArgs e)
        {
            okButton.Enabled = this.IsValid;
        }

        private void hostComboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            DataRowView dataRowView = null;

            dataRowView = (DataRowView)hostComboBox.SelectedItem;

            hostComboBox.Text = dataRowView["ServerName"] + string.Empty;

            okButton.Enabled = this.IsValid;
        }

        private void refreshButton_Click(object sender, EventArgs e)
        {
            try
            {
                PopulateObjects();
            }
            catch (Exception exp)
            {
                this.HandleError(exp);
            }
        }
    }
}