using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;

using SourceCode.Workflow.Management;

namespace Dauphine.Web.UI.SmartControls.Design
{
    class ProcessEditor : Editor
    {
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext typeDescriptorContext)
        {
            return UITypeEditorEditStyle.Modal;
        }        

        public override object EditValue(ITypeDescriptorContext typeDescriptorContext, IServiceProvider serviceProvider, object oValue)
        {            
            IWindowsFormsEditorService windowsFormsEditorService = null;
            ProcessPickerForm processPicker = null;
            ProcessSet processSet = null;
            ActionList actionList = null;
            WorkflowContextManager workflowContextManager = null;

            try
            {
                if (typeDescriptorContext.Instance != null && serviceProvider != null)
                {
                    windowsFormsEditorService = (IWindowsFormsEditorService)serviceProvider.GetService(typeof(IWindowsFormsEditorService));

                    if (windowsFormsEditorService != null)
                    {
                        if (typeDescriptorContext.Instance is ActionList)
                        {
                            actionList = (ActionList)typeDescriptorContext.Instance;

                            workflowContextManager = (WorkflowContextManager)actionList.Component;
                        }
                        else
                        {
                            workflowContextManager = (WorkflowContextManager)typeDescriptorContext.Instance;
                        }

                        processPicker = new ProcessPickerForm(workflowContextManager);

                        if (windowsFormsEditorService.ShowDialog(processPicker) == DialogResult.OK)
                        {
                            processSet = (ProcessSet)processPicker.Value;

                            oValue = processSet.FullName;
                        }
                    }
                }
            }
            catch (Exception exp)
            {
                this.DisplayError(serviceProvider, exp);
            }

            return oValue;
        }
    }    
}
