using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Drawing;
using System.Drawing.Design;

using Dauphine.Web.UI.SmartControls.Design;

namespace Dauphine.Web.UI.SmartControls
{
    [DefaultProperty("WorkflowContextManagerID")]
    [Designer(typeof(SmartLabelDesigner))]
    [ToolboxBitmap(typeof(SmartLabel))]
    [ToolboxData(@"<{0}:SmartLabel runat=""server""></{0}:SmartLabel>")]
    public class SmartLabel : Label, IField
    {
        private const string DefaultValue_WorkflowContextManagerID = "";
        private const string DefaultValue_Field = "";
        private const FieldScope DefaultValue_Scope = FieldScope.Process;
        private const FieldType DefaultValue_Type = FieldType.DataField;
        private const bool DefaultValue_PopulateOnLoad = true;

        [DefaultValue(DefaultValue_WorkflowContextManagerID)]
        [SmartDescription("DescriptionAttribute_FieldControl_WorkflowContextManagerID")]
        [SmartCategory("CategoryAttribute_FieldControl_WorkflowContextManagerID")]
        [IDReferenceProperty(typeof(WorkflowContextManager))]
        [TypeConverter(typeof(WorkflowContextManagerConverter))]
        public string WorkflowContextManagerID
        {
            get
            {
                Object oObj = ViewState["WorkflowContextManagerID"];

                if (oObj == null)
                {
                    ViewState["WorkflowContextManagerID"] = DefaultValue_WorkflowContextManagerID;
                }

                return ViewState["WorkflowContextManagerID"] + string.Empty;
            }

            set
            {
                ViewState["WorkflowContextManagerID"] = value;
            }
        }

        [DefaultValue(DefaultValue_Field)]
        [SmartDescription("DescriptionAttribute_FieldControl_Field")]
        [SmartCategory("CategoryAttribute_FieldControl_Field")]
        [Editor(typeof(FieldEditor), typeof(UITypeEditor))]
        public string Field
        {
            get
            {
                Object oObj = ViewState["Field"];

                if (oObj == null)
                {
                    ViewState["Field"] = DefaultValue_Field;
                }

                return ViewState["Field"] + string.Empty;
            }

            set
            {
                ViewState["Field"] = value;
            }
        }

        [DefaultValue(DefaultValue_Scope)]
        [SmartDescription("DescriptionAttribute_FieldControl_Scope")]
        [SmartCategory("CategoryAttribute_FieldControl_Scope")]
        public FieldScope Scope
        {
            get
            {
                Object oObj = ViewState["Scope"];

                if (oObj == null)
                {
                    ViewState["Scope"] = DefaultValue_Scope;
                }

                return (FieldScope)ViewState["Scope"];
            }

            set
            {
                ViewState["Scope"] = value;
            }
        }

        [ReadOnly(true)]
        [DefaultValue(DefaultValue_Type)]
        [SmartDescription("DescriptionAttribute_FieldControl_Type")]
        [SmartCategory("CategoryAttribute_FieldControl_Type")]
        public FieldType Type
        {
            get
            {
                return DefaultValue_Type;
            }
        }

        [DefaultValue(DefaultValue_PopulateOnLoad)]
        [SmartDescription("DescriptionAttribute_FieldControl_PopulateOnLoad")]
        [SmartCategory("CategoryAttribute_FieldControl_PopulateOnLoad")]
        public bool PopulateOnLoad
        {
            get
            {
                return DefaultValue_PopulateOnLoad;
            }
        }

        public bool LoadOnly
        {
            get
            {
                return true;
            }
        }

        public string CurrentValue
        {
            get
            {
                return this.Text;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            try
            {
                base.OnLoad(e);

                if (!this.Page.IsPostBack)
                {
                    this.Text = Convert.ToString(SmartField.GetCurrentValue(this));
                }
            }
            catch
            {
                throw;
            }
        }
    }
}
