using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;
using System.Reflection;

namespace Dauphine.Web.UI.SmartControls
{
    class PropertyManager
    {
        private object _component = null;
        private PropertyDescriptorCollection _propertyDescriptorCollection = null;

        public PropertyManager(object oComponent)
        {
            _component = oComponent;
            _propertyDescriptorCollection = TypeDescriptor.GetProperties(oComponent);
        }

        public PropertyDescriptor GetProperty(string strPropertyName)
        {
            PropertyDescriptor propertyDescriptor = null;

            if (_propertyDescriptorCollection[strPropertyName] != null)
            {
                propertyDescriptor = _propertyDescriptorCollection[strPropertyName];
            }
            else
            {
                throw new ArgumentException(string.Format(Resources.Exception_PropertyNotFound, new object[] { strPropertyName }));
            }

            return propertyDescriptor;
        }

        public object GetPropertyValue(string strPropertyName)
        {
            PropertyDescriptor propertyDescriptor = null;

            propertyDescriptor = this.GetProperty(strPropertyName);

            return propertyDescriptor.GetValue(_component); ;
        }

        public void SetPropertyValue(string strPropertyName, object oValue)
        {
            PropertyDescriptor propertyDescriptor = null;

            propertyDescriptor = this.GetProperty(strPropertyName);

            propertyDescriptor.SetValue(_component, oValue);
        }

        public void ResetPropertyValue(string strPropertyName)
        {
            PropertyDescriptor propertyDescriptor = null;

            propertyDescriptor = this.GetProperty(strPropertyName);

            propertyDescriptor.ResetValue(_component);
        }

        public bool IsPropertyReadOnly(string strPropertyName)
        {
            PropertyDescriptor propertyDescriptor = null;

            propertyDescriptor = this.GetProperty(strPropertyName);

            return propertyDescriptor.IsReadOnly;
        }
    }
}
